﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using ReaderA;
using System.Threading;

namespace AntDemo_9293TDB
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        int port = 0;
        int FrmHandle = -1;
        byte ComAddr = 255;
        int fCmdRet = 48;
        private void button5_Click(object sender, EventArgs e)
        {
            txt_num.Text = "0";
            NANT1.Text = "0";
            NANT2.Text = "0";
            NANT3.Text = "0";
            NANT4.Text = "0";
            lvList1.Items.Clear();
            lvList2.Items.Clear();
            lvList3.Items.Clear();
            lvList4.Items.Clear();
            listBox1.Items.Clear();
            cbUIDListforInfo.Items.Clear();
        }

        private void lvList2_SelectedIndexChanged(object sender, EventArgs e)
        {

        }

        private void Form1_Load(object sender, EventArgs e)
        {
            comboBox1.SelectedIndex = 0;
            comboBox2.SelectedIndex = 0;
            for (int i = 0; i < 256; i++)
            {
                cbBlockNumToOperation.Items.Add(i.ToString());
            }
            cbBlockNumToOperation.SelectedIndex = 0;
        }

        private void button1_Click(object sender, EventArgs e)
        {
            port=comboBox1.SelectedIndex+1;
            byte baud = (byte)comboBox2.SelectedIndex;
            fCmdRet = StaticClassReaderA.OpenComPort(port, ref ComAddr, baud,ref FrmHandle);
            if (fCmdRet==0)
            {
                btnGetReaderInfo_Click(null,null);
                button1.Enabled = false;
                button2.Enabled = true;
                button3.Enabled = true;
                btnGetReaderInfo.Enabled = true;
                btnGetSystemInfo.Enabled = true;
                btnReadSingleBlock.Enabled = true;
                btnWriteSingleBlock.Enabled = true;
            }
        }

        private void button2_Click(object sender, EventArgs e)
        {
            if (FrmHandle>0)
            {
                fCmdRet = StaticClassReaderA.CloseSpecComPort(FrmHandle);
                if (fCmdRet==0)
                {
                    nFlag = false;
                    button1.Enabled = true;
                    button2.Enabled = false;
                    button3.Enabled = false;
                    button4.Enabled = false;
                    FrmHandle = -1;
                    txt_num.Text = "0";
                    lvList1.Items.Clear();
                    lvList2.Items.Clear();
                    lvList3.Items.Clear();
                    lvList4.Items.Clear();
                    txt_num.Text = "0";
                    listBox1.Items.Clear();
                    cbUIDListforInfo.Items.Clear();
                    ClearReaderInformation();
                    btnGetReaderInfo.Enabled = false;
                    btnGetSystemInfo.Enabled = false;
                    btnReadSingleBlock.Enabled = false;
                    btnWriteSingleBlock.Enabled = false;
                }
            }
        }
        #region  16进制字符串到数组之间的相互转换
        private byte[] HexStringToByteArray(string s)
        {
            s = s.Replace(" ", "");
            byte[] buffer = new byte[s.Length / 2];
            for (int i = 0; i < s.Length; i += 2)
                buffer[i / 2] = (byte)Convert.ToByte(s.Substring(i, 2), 16);
            return buffer;
        }
        private string ByteArrayToHexString(byte[] data)
        {
            StringBuilder sb = new StringBuilder(data.Length * 3);
            foreach (byte b in data)
                sb.Append(Convert.ToString(b, 16).PadLeft(2, '0'));
            return sb.ToString().ToUpper();
        }
        #endregion
        bool nFlag = true;
        int delayTime = 0;
        private void button3_Click(object sender, EventArgs e)
        {
            button3.Enabled = false;
            button4.Enabled = true;
            nFlag = true;
            ListBox lv =new ListBox();
            Label lb = new Label();
            byte _Output = 0;
           // delayTime = Convert.ToInt32(textBox1.Text, 10);
            while(nFlag)
            {
                ListBox tlst = new ListBox();
                for(int m=0;m<4;m++)
                {
                    Application.DoEvents();
                    switch (m)
                    {
                        case 0:
                            lv = lvList1;
                            lb = NANT1;
                            if (!checkBox1.Checked) continue;
                            _Output = 1;
                            fCmdRet = StaticClassReaderA.SetActiveANT(ref ComAddr, ref _Output, FrmHandle);
                            NANT1.Text = "0";
                            break;
                        case 1:
                            lv = lvList2;
                            lb = NANT2;
                            if (!checkBox2.Checked) continue;
                            _Output = 2;
                            fCmdRet = StaticClassReaderA.SetActiveANT(ref ComAddr, ref _Output, FrmHandle);
                            NANT2.Text = "0";
                            break;
                        case 2:
                            lv = lvList3;
                            lb = NANT3;
                            if (!checkBox3.Checked) continue;
                            _Output = 4;
                            fCmdRet = StaticClassReaderA.SetActiveANT(ref ComAddr, ref _Output, FrmHandle);
                            NANT3.Text = "0";
                            break;
                        case 3:
                            lv = lvList4;
                            lb = NANT4;
                            if (!checkBox4.Checked) continue;
                            _Output = 8;
                            fCmdRet = StaticClassReaderA.SetActiveANT(ref ComAddr, ref _Output, FrmHandle);
                            NANT4.Text = "0";
                            break;
                    }
                    byte state=6;
                    byte AFI=0;
                    byte cardnum=0;
                    byte[] UID=new byte[3000];
                    Thread.Sleep(delayTime);
                    fCmdRet = StaticClassReaderA.Inventory(ref ComAddr, ref state, ref AFI, UID, ref cardnum,FrmHandle);
                    lv.Items.Clear();
                    if(cardnum==0) continue;
                    byte[] daw = new byte[cardnum*9];
                    Array.Copy(UID, 0, daw, 0, cardnum * 9);
                    string uidlist = ByteArrayToHexString(daw);
                    for (int i = 0; i < cardnum;i++ )
                    {
                        string temp = uidlist.Substring(i * 18 + 2, 16); 
                        lv.Items.Add(GetReverse(temp));
                    }
                    lv.SelectedIndex = lv.Items.Count - 1;
                    while(fCmdRet==0x0B)
                    {
                        state = 2;
                        cardnum = 0;
                        fCmdRet = StaticClassReaderA.Inventory(ref ComAddr, ref state, ref AFI, UID, ref cardnum, FrmHandle);
                        if (cardnum == 0) break;
                        daw = new byte[cardnum * 9];
                        Array.Copy(UID, 0, daw, 0, cardnum * 9);
                        uidlist = ByteArrayToHexString(daw);
                        for (int i = 0; i < cardnum; i++)
                        {
                            string temp = uidlist.Substring(i * 18 + 2, 16);
                            lv.Items.Add(GetReverse(temp));
                        }
                        lv.SelectedIndex = lv.Items.Count - 1;
                    }
                    lb.Text = lv.Items.Count.ToString();
                    Application.DoEvents();
                    for (int p = 0; p < lv.Items.Count;p++ )
                    {
                        string temp = lv.Items[p].ToString();
                        if (listBox1.Items.IndexOf(temp) == -1)
                        {
                            cbUIDListforInfo.Items.Add(temp);
                            listBox1.Items.Add(temp);
                        }
                    }
                    if (cbUIDListforInfo.Items.Count > 0)
                        cbUIDListforInfo.SelectedIndex = 0;
                }
                txt_num.Text = listBox1.Items.Count.ToString();
            }
        }
        private string GetReverse(string UID)
        {
            string result = "";
            for (int i = 0; i < UID.Length / 2;i++ )
            {
                result += UID.Substring((7-i)*2,2);
            }
            
            return result;
        }
        private void button4_Click(object sender, EventArgs e)
        {
            nFlag = false;
            button3.Enabled = true;
            button4.Enabled = false;
        }
        private void ClearReaderInformation()
        {
            tbReadInfoAddr.Text = "";
            tbReaderInfoVersion.Text = "";
            tbReaderInfoType.Text = "";
            tbReaderInfoInventoryScanTime.Text = "";
            tbReaderInfoProtocol.Text = "";
        }
        private void btnGetReaderInfo_Click(object sender, EventArgs e)
        {
             byte[] verInfo = new byte[2];
            byte[] trType = new byte[2];
            byte readerType = 0;
            byte inventoryScanTime = 0;
            int fCmdRet = 0x30;
            int fCmdRet2 = 0x30;
            ClearReaderInformation();
            fCmdRet = StaticClassReaderA.GetReaderInformation(ref ComAddr, verInfo, 
                                                          ref readerType, trType, 
                                                          ref inventoryScanTime,
                                                          FrmHandle);
            if (fCmdRet == 0)
            {
                tbReadInfoAddr.Text = Convert.ToString(ComAddr, 16).PadLeft(2, '0').ToUpper();
                tbReaderInfoVersion.Text = Convert.ToString(verInfo[0], 10).PadLeft(2, '0') + "." +
                                           Convert.ToString(verInfo[1], 10).PadRight(2, '0');
                tbReaderInfoType.Text ="HFReader";
                if ((trType[1] & 0x08) == 0x08)
                { tbReaderInfoProtocol.Text = "ISO/IEC 15693"; }
                tbReaderInfoInventoryScanTime.Text = inventoryScanTime.ToString().ToUpper();
            }
        }

        private void bntSetActiveANT_Click(object sender, EventArgs e)
        {
            int fCmdRet = 0x30;
            byte ANTSet = 0;
            if (rbANT1.Checked)
            { ANTSet = 1; }
            else if (rbANT2.Checked)
            { ANTSet = 2; }
            else if (rbANT3.Checked)
            { ANTSet = 4; }
            else if (rbANT4.Checked)
            { ANTSet = 8; }
            fCmdRet = StaticClassReaderA.SetActiveANT(ref ComAddr, ref ANTSet, FrmHandle);
            if (fCmdRet==0)
            {
                MessageBox.Show("Success");
            }
            else
            {
                MessageBox.Show("failed");
            }
        }

        private void tabControl1_SelectedIndexChanged(object sender, EventArgs e)
        {
            nFlag = false;
            button3.Enabled = true;
            button4.Enabled = false;
        }
        private void GetTagInfo(byte FirmCode, byte OtherCode, ref string FirmName, ref byte BlockSize, ref byte BlockNum, ref string TagType)
        {
            switch (FirmCode)
            {
                case 0x02:
                    BlockSize = 4;
                    BlockNum = 16;
                    TagType = "B";
                    FirmName = "STMicroelectronics";
                    break;
                case 0x04:
                    BlockSize = 4;
                    BlockNum = 28;
                    TagType = "B";
                    FirmName = "Philips Semiconductors";
                    break;
                case 0x05:
                    BlockSize = 4;
                    BlockNum = 58;
                    if (OtherCode == 0xE0)
                        BlockNum = 250;
                    else if (OtherCode == 0x60)
                        BlockNum = 58;
                    TagType = "B";
                    FirmName = "Infineon";
                    break;
                case 0x07:
                    BlockSize = 4;
                    BlockNum = 64;
                    TagType = "A";
                    FirmName = "Texas Instruments";
                    break;
                case 0x08:
                    BlockSize = 8;
                    BlockNum = 250;
                    TagType = "A/B";
                    FirmName = "Fujitsu";
                    break;
                case 0x16:
                    BlockSize = 4;
                    BlockNum = 14;
                    TagType = "A";
                    FirmName = "EM Microelectronic";
                    break;
                default:
                    BlockSize = 4;
                    BlockNum = 255;
                    TagType = "B";
                    FirmName = "";
                    break;
            }
        }
        private void btnGetSystemInfo_Click(object sender, EventArgs e)
        {
            int fCmdRet = 0x30;
            byte errorCode = 0;
            byte state = 0;
            byte informationFlag = 0;
            byte DSFID = 0;
            byte AFI = 0;
            byte ICReference = 0;
            byte[] UIDI = { 0, 0, 0, 0, 0, 0, 0, 0 };
            byte[] UIDO = new byte[8];
            byte[] menorySize = new byte[2];
            byte blockSize = 0, blockNum = 0;
            string tagWriteType = "";
            string FirmName = "";
            int i;

            //btnReadSingleBlock.Enabled = false;
            //btnReadMultiBlock.Enabled = false;
            //btnWriteSingleBlock.Enabled = false;
            tbSystemInfoData.Text = "";
            tbSystemInfo.Text = "";
            cbWriteType.Items.Clear();
            //cbBlockNumToOperation.Items.Clear();
            cbMaxBlockNum.Items.Clear();
            cbBlockSize.Items.Clear();

            state = 0;
            if (cbUIDListforInfo.Text =="")
            {
                return;
            }
            UIDI = HexStringToByteArray(GetReverse(cbUIDListforInfo.SelectedItem.ToString()));
            fCmdRet = StaticClassReaderA.GetSystemInformation(ref ComAddr, ref state, UIDI, ref informationFlag, UIDO,
                                                          ref DSFID, ref AFI, menorySize,
                                                          ref ICReference, ref errorCode, FrmHandle);
            if (fCmdRet == 0)
            {
                tbSystemInfoData.Text = GetReverse(ByteArrayToHexString(UIDO).Replace(" ", ""));
                tbSystemInfo.Text = "UID0: " + GetReverse(ByteArrayToHexString(UIDO).Replace(" ", ""));
                if ((informationFlag & 0x01) == 0x01)
                {
                    tbSystemInfoData.Text = tbSystemInfoData.Text + " " + Convert.ToString(DSFID, 16).PadLeft(2, '0').ToUpper();
                    tbSystemInfo.Text = tbSystemInfo.Text + " " + "DSFID: " + Convert.ToString(DSFID, 16).PadLeft(2, '0').ToUpper();
                }
                if ((informationFlag & 0x02) == 0x02)
                {
                    tbSystemInfoData.Text = tbSystemInfoData.Text + " " + Convert.ToString(AFI, 16).PadLeft(2, '0').ToUpper();
                    tbSystemInfo.Text = tbSystemInfo.Text + " " + "AFI: " + Convert.ToString(AFI, 16).PadLeft(2, '0').ToUpper();
                }
                if ((informationFlag & 0x04) == 0x04)
                {
                    tbSystemInfoData.Text = tbSystemInfoData.Text + " " + ByteArrayToHexString(menorySize).Replace(" ", "");
                    tbSystemInfo.Text = tbSystemInfo.Text + " " + "MemorySize: " + ByteArrayToHexString(menorySize).Replace(" ", "");
                }
                if ((informationFlag & 0x08) == 0x08)
                {
                    tbSystemInfoData.Text = tbSystemInfoData.Text + " " + Convert.ToString(ICReference, 16).PadLeft(2, '0').ToUpper();
                    tbSystemInfo.Text = tbSystemInfo.Text + " " + "ICReference: " + Convert.ToString(ICReference, 16).PadLeft(2, '0').ToUpper();
                }

                GetTagInfo(UIDO[6], UIDO[7], ref FirmName, ref blockSize, ref blockNum, ref tagWriteType);

                cbWriteType.Items.Add("A ");
                cbWriteType.Items.Add("B ");
                if (tagWriteType.IndexOf("B") != -1)
                { cbWriteType.SelectedIndex = 1; }
                else
                { cbWriteType.SelectedIndex = 0; }

                cbBlockSize.Items.Add("4");
                cbBlockSize.Items.Add("8");
                if (blockSize == 8)
                { cbBlockSize.SelectedIndex = 1; }
                else
                { cbBlockSize.SelectedIndex = 0; }

                for (i = 0; i < 256; i++)
                {
                    cbMaxBlockNum.Items.Add(i.ToString());
                }
                cbMaxBlockNum.SelectedIndex = blockNum - 1;
            }
            else
            {
                cbWriteType.Items.Add("A ");
                cbWriteType.Items.Add("B ");
                cbWriteType.SelectedIndex = 1; 

                cbBlockSize.Items.Add("4");
                cbBlockSize.Items.Add("8");
                cbBlockSize.SelectedIndex = 0;

                for (i = 0; i < 256; i++)
                {
                    cbMaxBlockNum.Items.Add(i.ToString());
                }
                cbMaxBlockNum.SelectedIndex =255;
            }
        }
        private byte GetState(byte blocSize, string writeType, bool isCheckWriteType)
        {
            if (!isCheckWriteType)
            {
                if (blocSize == 4)
                { return 0; }
                else
                { return 4; }
            }
            else
            {
                if (blocSize == 4)
                {
                    if (writeType.IndexOf("A") >= 0)            //A类标签,每个块4字节
                    {
                        return (byte)(0);
                    }
                    else                                        //B类标签,每个块4字节
                    {
                        return (byte)(8);
                    }
                }
                else
                {
                    if (writeType.IndexOf("A") >= 0)            //A类标签,每个块8字节
                    {
                        return (byte)(4);
                    }
                    else                                        //B类标签,每个块8字节
                    {
                        return (byte)(0x0C);
                    }
                }

            }
        }
        private void btnReadSingleBlock_Click(object sender, EventArgs e)
        {
            byte state = 0;
            byte errorCode = 0;
            int fCmdRet = 0x30;
            byte blockNum = 0;
            byte blockSecStatus = 0;
            byte[] UID = { 0, 0, 0, 0, 0, 0, 0, 0 };
            tbDataReaded.Text = "";

            if (((cbUIDListforInfo.Items.Count == 0) ||
                 (cbUIDListforInfo.SelectedItem == null)))
            {
                MessageBox.Show("Select UID");
                return;
            }

            if ((cbWriteType.SelectedItem == null) || (cbMaxBlockNum.SelectedItem == null) || (cbBlockSize.SelectedItem == null) || (cbBlockNumToOperation.SelectedItem == null))
            {
                return;
            }
            blockNum = (byte)cbBlockNumToOperation.SelectedIndex;
            state = GetState((byte)(cbBlockSize.SelectedIndex * 4 + 4), cbBlockSize.SelectedItem.ToString(), false);
            byte[] data = new byte[cbBlockSize.SelectedIndex * 4 + 4];

            UID = HexStringToByteArray(GetReverse(cbUIDListforInfo.SelectedItem.ToString()));

            fCmdRet = StaticClassReaderA.ReadSingleBlock(ref ComAddr, ref state, UID, blockNum, ref blockSecStatus, data, ref errorCode, FrmHandle);
            if (fCmdRet == 0)
            {
                tbDataReaded.Text = blockSecStatus.ToString("x2") + " " + ByteArrayToHexString(data).Replace(" ", "");
            }
            else
            {
                tbDataReaded.Text = "";
            }
        }

        private void btnWriteSingleBlock_Click(object sender, EventArgs e)
        {
            byte state = 0;
            byte errorCode = 0;
            int fCmdRet = 0x30;
            byte blockNum = 0;
            byte[] UID = { 0, 0, 0, 0, 0, 0, 0, 0 };
            if (tbDataToWrite.Text.Length != (cbBlockSize.SelectedIndex * 4 + 4) * 2)
            {
                MessageBox.Show("Input Correct Data");
                return;
            }
            if (((cbUIDListforInfo.Items.Count == 0) ||
                (cbUIDListforInfo.SelectedItem == null)))
            {
                MessageBox.Show("Select UID");
                return;
            }
            byte[] data = new byte[cbBlockSize.SelectedIndex * 4 + 4];
            data = HexStringToByteArray(tbDataToWrite.Text);
            UID = HexStringToByteArray(GetReverse(cbUIDListforInfo.SelectedItem.ToString()));
            blockNum = (byte)cbBlockNumToOperation.SelectedIndex;
            state = GetState((byte)(cbBlockSize.SelectedIndex * 4 + 4), cbWriteType.SelectedItem.ToString(), true);

            fCmdRet = StaticClassReaderA.WriteSingleBlock(ref ComAddr, ref state, UID, blockNum, data, ref errorCode, FrmHandle);
            if (fCmdRet==0)
            {
                MessageBox.Show("Success");
            }
            else
            {
                MessageBox.Show("Failed");
            }
            
        }


    }
}